/************ Drop: Database ***************/
DROP DATABASE IF EXISTS delegationdb;

/************ Create: Database ***************/
CREATE DATABASE delegationdb;

/************ Use Delegation DB ***************/

use delegationdb;

/******************** Add Tables ************************/

CREATE TABLE db_info
(
    version       VARCHAR(5) NOT NULL,
    creationTime  TIMESTAMP  NOT NULL
) ENGINE=InnoDB;

CREATE TABLE t_credential_cache (
   dlg_id	VARCHAR(255),
   dn		VARCHAR(255),
   cert_request	TEXT NOT NULL,
   priv_key	TEXT NOT NULL,
   voms_attrs	TEXT,
   PRIMARY KEY (dlg_id, dn)
) ENGINE=InnoDB;

CREATE TABLE t_credential (
   dlg_id	    VARCHAR(255),
   dn		    VARCHAR(255),
   fqan             VARCHAR(255),
   vo               VARCHAR(50),
   local_user       VARCHAR(100),
   local_user_group VARCHAR(100),
   proxy	    TEXT NOT NULL,
   voms_attrs       TEXT,
   info             TEXT,
   start_time       DATETIME,
   termination_time DATETIME,
   last_update_time DATETIME,
   PRIMARY KEY (dlg_id, dn)
) ENGINE=InnoDB;


CREATE TABLE t_credential_vers (
   major	INT,
   minor	INT,
   patch	INT
) ENGINE=InnoDB;

commit;

/******************** Insert row in t_credential_vers table ************************/

insert into t_credential_vers(major, minor, patch) values ('1','2','0');

/************ Insert row in db_info ************************************************/    
insert into db_info (version, creationTime) values ('2.4', now());

commit;
