/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package org.glite.ce.cream.ws.authz;

import java.util.Calendar;

import javax.xml.namespace.QName;

//import org.apache.axis.AxisFault;
import org.apache.axis.MessageContext;
import org.apache.log4j.Logger;
import org.glite.ce.creamapi.ws.cream2.types.AuthorizationFault;
import org.glite.security.delegation.DelegationException;

public class AuthorizationHandler
    extends org.glite.ce.commonj.authz.AuthorizationHandler {

    static final long serialVersionUID = 1273759224;

    private static String DELEGATION_NS = "http://www.gridsite.org/namespaces/delegation-2";

    private static Logger logger = Logger.getLogger(AuthorizationHandler.class.getName());

    /**
     * The default constructor of the class. It just calls the BasicHandler
     * constructor
     */
    public AuthorizationHandler() {
        super();
    }

    protected Object getAuthorizationFault(String message) {
        /*
         * TODO verify DelegationException
         */
        //QName qName = this.getOperation(MessageContext.getCurrentContext());
        //if (qName != null && qName.getNamespaceURI().equals(DELEGATION_NS)) {
        //    return new DelegationException(message);
        //}

        AuthorizationFault fault = new AuthorizationFault();
        fault.setMethodName("invoke");
        fault.setDescription(message);
        fault.setErrorCode("0");
        fault.setFaultCause(message);
        fault.setTimestamp(Calendar.getInstance());
        return fault;
    }


    protected QName getOperation(javax.xml.rpc.handler.MessageContext context) {
        QName result = super.getOperation(context);
        if (result == null) {
            /*
             * This workaround is required because axis is not able to retrieve
             * the jobList operation
             */
            MessageContext msgContext = (MessageContext) context;
            String soapAction = msgContext.getSOAPActionURI();
            if ("http://glite.org/2007/11/ce/cream/JobList".equals(soapAction)) {
                result = new QName("JobList");
            }
        }

        return result;
    }

}
