/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Luigi Zangrando, <luigi.zangrando@pd.infn.it>
 *
 */

package org.glite.ce.cream.ws.delegation;

public class DelegationProxyEvent implements Cloneable {
    public final static int DELEGATIONPROXY_ADDED = 0;
    public final static int DELEGATIONPROXY_UPDATED = 1;
    public final static int DELEGATIONPROXY_REMOVED = 2;
    private int eventType = -1;
    private DelegationProxyInfo dpi = null;

    public DelegationProxyEvent(int eventType, String delegationId, String dproxy) {
        this.eventType = eventType;
        this.dpi = new DelegationProxyInfo(delegationId, dproxy);
    }


    public DelegationProxyEvent(int eventType, DelegationProxyInfo delegProxyInfo) {
        this.eventType = eventType;
        this.dpi = delegProxyInfo;
    }

    public Object clone() {
        return new DelegationProxyEvent(eventType, dpi);
    }

    public DelegationProxyInfo getDelegationProxyInfo() {
        return dpi;
    }

    public int getEventType() {
        return eventType;
    }
}
