/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package org.glite.ce.cream.ws.delegation.storage;

import java.util.List;

import org.glite.ce.cream.ws.delegation.DelegationProxyInfo;
import org.glite.ce.cream.ws.delegation.DelegationProxyListener;
import org.glite.security.delegation.storage.GrDPStorage;
import org.glite.security.delegation.storage.GrDPStorageException;

public interface CREAMGrDPStorageInterface extends GrDPStorage {

    public void addDelegationProxyListener(DelegationProxyListener l);

    public void removeDelegationProxyListener(DelegationProxyListener l);
    
    public void destroy();

    public List<DelegationProxyInfo> findExpiredDelegationProxy() throws GrDPStorageException;

    public DelegationProxyListener[] getDelegationProxyListeners();

    public void insertDelegationProxy(DelegationProxyInfo proxy) throws GrDPStorageException;

    public void deleteDelegationProxy(String delegationId, String dn, String localUser) throws GrDPStorageException;
        
    public void updateDelegationProxy(DelegationProxyInfo proxy) throws GrDPStorageException;
    
    public DelegationProxyInfo getDelegationProxy(String delegationId, String dn, String localUser) throws GrDPStorageException;
}
